![Web Cover](art/cover-web.jpg)
![Android Cover](art/cover-android.jpg)
![Desktop Cover](art/cover-desktop.jpg)


<a href="https://github.com/Shabinder/SpotiFlyer"><img src="https://github.com/Shabinder/SpotiFlyer/blob/Compose/art/SpotiFlyer.svg" align="left" height="80" width="80" ></a>

# SpotiFlyer
- **Kotlin Multiplatform** Music Downloader ,supports **Spotify, Youtube, Gaana**.

Supports- Playlist, Albums, Tracks. _(If You know Any Source for Episodes/Podcasts create an Issue sharing It.)_

 **Currently running on:**
 - [Android (Jetpack Compose)](https://github.com/Shabinder/SpotiFlyer/releases/download/v2.2.0/SpotiFlyer-v2.2.0.apk) 
 - [Desktop (Compose for Desktop) <sup>β</sup>](https://github.com/Shabinder/SpotiFlyer#running-desktop-application)
 - [Web (Kotlin/JS + React Wrapper) <sup>β</sup>](http://shabinder.github.io/SpotiFlyer/)
 - [_(WIP)_ IOS SOON (SWIFTUI)](https://github.com/Shabinder/spotiflyer-ios)

[![SpotiFlyer Web App](https://img.shields.io/github/v/release/Shabinder/SpotiFlyer?color=FF7139&label=SpotiFlyer&logo=firefox&style=for-the-badge)](https://shabinder.github.io/SpotiFlyer/)    [![SpotiFlyer Android App](https://img.shields.io/github/v/release/Shabinder/SpotiFlyer?color=7885FF&label=SpotiFlyer&logo=android&style=for-the-badge)](https://github.com/Shabinder/SpotiFlyer/releases/download/v2.2.0/SpotiFlyer-v2.2.0.apk)
</br>
<!--[![Build Status](https://github.com/Shabinder/SpotiFlyer/blob/master/app/build_passing.svg)](https://github.com/Shabinder/SpotiFlyer/releases)
![API](https://img.shields.io/badge/API-26%2B-brightgreen.svg)
</br>-->
[![GitHub stars](https://img.shields.io/github/stars/Shabinder/SpotiFlyer?style=social)](https://github.com/Shabinder/SpotiFlyer/stargazers)
[![GitHub forks](https://img.shields.io/github/forks/Shabinder/SpotiFlyer?style=social)](https://github.com/Shabinder/SpotiFlyer/network/members)
[![GitHub watchers](https://img.shields.io/github/watchers/Shabinder/SpotiFlyer?style=social)](https://github.com/Shabinder/SpotiFlyer/watchers)

***Encourage this repo by giving it a Star⭐ .***

SpotiFlyer is an **App**(Written in **Kotlin**), which **aims** to work as:
  - **Downloads**: Albums, Tracks and Playlists,etc 
  - **Save your Data** ,by not **_Streaming_** your Fav Songs Online again & again(Just Download Them!)
  - **No ADS!** 
  - **Works straight out of the box** and does not require you to generate or mess with your API keys (already included).
  
### Supported Platforms:
- Spotify
- Gaana
- Youtube
- Youtube Music
- _(more coming soon)_

### Downloads
The latest release and pre-release versions are available on GitHub.
Or to save a click, [this link](https://github.com/Shabinder/SpotiFlyer/releases/latest) should always point to the most recent release.

[![APK Download](https://img.shields.io/github/downloads/Shabinder/SpotiFlyer/total?style=for-the-badge&logo=android&color=17B2E7)](https://github.com/Shabinder/SpotiFlyer/releases/download/v2.3.0/SpotiFlyer.v2.3.0.apk)

### Running desktop application
```./gradlew :desktop:run```


### Want to Contribute 🙋‍♂️?
Want to contribute? Great!
All contributions are welcome, from code to documentation to graphics to design suggestions to bug reports. Please use GitHub to its fullest-- contribute Pull Requests, contribute tutorials or other wiki content-- whatever you have to offer, we can use it!


**Please Donate to support me and my work!**
</br>
[![ko-fi](https://ko-fi.com/img/githubbutton_sm.svg)](https://ko-fi.com/R6R84CS1D)
</br>
<a href="https://opencollective.com/spotiflyer/donate">
    <img src="https://opencollective.com/spotiflyer/tiers/donate.svg?avatarHeight=52">
</a>
[![paypal](https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif)](https://paypal.me/shabinder)

### Want to discuss? 💬
Have any questions, doubts or want to present your opinions, views? You're always welcome. You can [start discussions](https://github.com/Shabinder/SpotiFlyer/discussions).

### Todos 📄
 - Write **Tests**.
 - Support for Podcasts/Episodes and Shows.
 - Preference Screen.
 - Another Source for Music in addition to youtube.
 - Build a Media Player into this app. _SEE: #113 _
 
### Note
The availability of YouTube Music in your country is important for this app to work since we use YouTube Music to filter out our search results.
To check if YouTube Music is available in your country, visit [YouTube Music](https://music.youtube.com).

I am hosting a **server for WEB APP on my own personal device** , so expect some downtimes, If you have a **server** available and would like to share , open an issue or ping me wherever you can get a hold of me.

License
![GPL-License](https://img.shields.io/github/license/Shabinder/SpotiFlyer?style=flat-square)
----
**GPL-3.0 License**
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

***Free Software, Hell Yeah!***


Credits
----
 - Some Logos are Based on Logos by [Freepik](https://www.freepik.com/).
  
  
Disclaimer
----
Downloading copyright songs may be illegal in your country. This tool is for educational purposes only and was created only to show how Music Platform's Apis like Spotify's API can be exploited to download music. Please support the artists by buying their music.

